Package com.documentum.fc.client

# Interface IDfType

All Superinterfaces:
  `IDfPersistentObject`, `IDfTypedObject`

public interface IDfType extends IDfPersistentObject
This interface provides access to type-related data stored in type objects. A type object may represent a persistent type, such as dm_document, or a non-persistent type, such as data returned from a query.

- ## Field Summary

  Fields
  Modifier and Type
  Field
  Description
  `static final int`
  `DF_BOOLEAN`
  Represents the boolean datatype.
  `static final int`
  `DF_DOUBLE`
  Represents the double datatype.
  `static final int`
  `DF_ID`
  Represents the ID datatype.
  `static final int`
  `DF_INTEGER`
  Represents the integer datatype.
  `static final int`
  `DF_STRING`
  Represents the string datatype.
  `static final int`
  `DF_TIME`
  Represents the time, or date, datatype.
  `static final int`
  `DF_UNDEFINED`
  Represents an undefined datatype.

  ### Fields inherited from interface com.documentum.fc.client.IDfPersistentObject

  `CURRENCY_CHECK_ALWAYS, CURRENCY_CHECK_FIRST_ACCESS, CURRENCY_CHECK_NEVER, CURRENCY_CHECK_ONCE_PER_SCOPE`

- ## Method Summary

  Modifier and Type
  Method
  Description
  `int`
  `findTypeAttrIndex(String attrName)`
  Returns the index of an attribute.
  `String`
  `getDescription()`
  Returns the user-defined label for a type.
  `String`
  `getName()`
  Returns a type's name.
  `String`
  `getSuperName()`
  Returns the name of a type's supertype.
  `IDfType`
  `getSuperType()`
  Returns a type's super type.
  `IDfAttr`
  `getTypeAttr(int attrIndex)`
  Returns an IDfAttr representing the type's attribute located at the position `attrIndex` in this object's list of attributes.
  `IDfList`
  `getTypeAttrAssistanceWithValues(String attrName, IDfId policyId, String state, IDfList depAttrNameList, IDfList depAttrValueListList)`
  Deprecated.
  `IDfList`
  `getTypeAttrAsstDependencies(String attrName, IDfId policyId, String state)`
  Deprecated.
  `int`
  `getTypeAttrCount()`
  Returns the number of attributes in a type.
  `int`
  `getTypeAttrDataType(String attrName)`
  Returns the datatype of an attribute.
  `int`
  `getTypeAttrDataTypeAt(int index)`
  Returns the datatype of an attribute.
  `String`
  `getTypeAttrDescription(String attrName)`
  Returns the user-defined label for an attribute.
  `String`
  `getTypeAttrDescriptionAt(int index)`
  Returns the user-defined label for an attribute.
  `int`
  `getTypeAttrLength(String attrName)`
  Returns the maximum number of characters in a string-valued attribute.
  `int`
  `getTypeAttrLengthAt(int index)`
  Returns the maximum number of characters in a string-valued attribute.
  `String`
  `getTypeAttrNameAt(int index)`
  Returns an attribute name for a type.
  `IDfValidator`
  `getTypeValidator(IDfId policyId, String state)`
  Returns the IDfValidator that is assocated with this IDfType.
  `String`
  `getTypeWidgetType(int environment, String attrName, IDfId policyId, String state)`
  Deprecated.
  `boolean`
  `isSubTypeOf(String typeName)`
  Indicates whether a type is a subtype of type `typeName`.
  `boolean`
  `isTypeAttrRepeating(String attrName)`
  Indicates whether an attribute is repeating.
  `boolean`
  `isTypeAttrRepeatingAt(int index)`
  Indicates whether an attribute is repeating.
  `boolean`
  `isTypeOf(String typeName)`
  Returns true if an object of this type is also an object of type `typeName`.
  `void`
  `validateTypeAttrRulesWithValue(String attrName, IDfId policyId, String state, String value, IDfList depAttrNameList, IDfList depAttrValueListList, int stopAfterNumOfErrors)`
  Deprecated.
  `void`
  `validateTypeAttrRulesWithValues(String attrName, IDfId policyId, String state, IDfList values, IDfList depAttrNameList, IDfList depAttrValueListList, int stopAfterNumOfErrors)`
  Deprecated.
  `void`
  `validateTypeObjRulesWithValues(IDfList attrNameList, IDfId policyId, String state, IDfList valueListList, int stopAfterNumOfErrors)`
  Deprecated.

  ### Methods inherited from interface com.documentum.fc.client.IDfPersistentObject

  `addChildRelative, addParentRelative, apiExec, apiGet, apiSet, destroy, fetch, fetchWithCaching, getAttrAssistance, getAttrAssistanceWithValues, getAttrAsstDependencies, getChildRelatives, getParentRelatives, getPartition, getType, getValidator, getVStamp, getWidgetType, isDeleted, isDirty, isInstanceOf, isNew, isReplica, lock, lockEx, registerEvent, removeChildRelative, removeParentRelative, revert, save, setPartition, signoff, unRegisterEvent, unRegisterEventEx, validateAllRules, validateAttrRules, validateAttrRulesWithValue, validateAttrRulesWithValues, validateObjRules, validateObjRulesWithValues`

  ### Methods inherited from interface com.documentum.fc.client.IDfTypedObject

  `appendBoolean, appendDouble, appendId, appendInt, appendString, appendTime, appendValue, dump, enumAttrs, findAttrIndex, findBoolean, findDouble, findId, findInt, findString, findTime, findValue, getAllRepeatingStrings, getAttr, getAttrCount, getAttrDataType, getBoolean, getDouble, getId, getInt, getLong, getObjectId, getObjectSession, getOriginalSession, getRepeatingBoolean, getRepeatingDouble, getRepeatingId, getRepeatingInt, getRepeatingLong, getRepeatingString, getRepeatingTime, getRepeatingValue, getSession, getSessionManager, getString, getTime, getValue, getValueAt, getValueCount, hasAttr, insertBoolean, insertDouble, insertId, insertInt, insertString, insertTime, insertValue, isAttrRepeating, isNull, remove, removeAll, setBoolean, setDouble, setId, setInt, setNull, setRepeatingBoolean, setRepeatingDouble, setRepeatingId, setRepeatingInt, setRepeatingString, setRepeatingTime, setRepeatingValue, setSessionManager, setString, setTime, setValue, truncate`

- ## Field Details

  - ### DF_BOOLEAN

    static final int DF_BOOLEAN
    Represents the boolean datatype.
    See Also:
      - Constant Field Values

  - ### DF_INTEGER

    static final int DF_INTEGER
    Represents the integer datatype.
    See Also:
      - Constant Field Values

  - ### DF_STRING

    static final int DF_STRING
    Represents the string datatype.
    See Also:
      - Constant Field Values

  - ### DF_ID

    static final int DF_ID
    Represents the ID datatype.
    See Also:
      - Constant Field Values

  - ### DF_TIME

    static final int DF_TIME
    Represents the time, or date, datatype.
    See Also:
      - Constant Field Values

  - ### DF_DOUBLE

    static final int DF_DOUBLE
    Represents the double datatype.
    See Also:
      - Constant Field Values

  - ### DF_UNDEFINED

    static final int DF_UNDEFINED
    Represents an undefined datatype.
    See Also:
      - Constant Field Values

- ## Method Details

  - ### getName

    String getName() throws DfException
    Returns a type's name.
    Throws:
      `DfException` - if a server error occurs

  - ### getSuperName

    String getSuperName() throws DfException
    Returns the name of a type's supertype.
    Throws:
      `DfException` - if a server error occurs

  - ### getDescription

    String getDescription() throws DfException
    Returns the user-defined label for a type.
    Throws:
      `DfException` - if a server error occurs

  - ### getSuperType

    IDfType getSuperType() throws DfException
    Returns a type's super type.

    If the type does not have a supertype, this method returns `NULL`.
    Throws:
      `DfException` - thrown if the supertype exists but cannot be found or if a server error occurs

  - ### isTypeOf

    boolean isTypeOf(String typeName) throws DfException
    Returns true if an object of this type is also an object of type `typeName`.
    Throws:
      `DfException` - if an error occurs

  - ### isSubTypeOf

    boolean isSubTypeOf(String typeName) throws DfException
    Indicates whether a type is a subtype of type `typeName`. Note: This method returns false if its argument is not a direct supertype of the given type.
    Throws:
      `DfException` - if a server error occurs

  - ### findTypeAttrIndex

    int findTypeAttrIndex(String attrName) throws DfException
    Returns the index of an attribute.

    This method returns -1 if the specified attribute does not exist.

    Throws:
      `DfException` - if a server error occurs

  - ### getTypeAttrCount

    int getTypeAttrCount() throws DfException
    Returns the number of attributes in a type.
    Throws:
      `DfException` - if a server error occurs

  - ### getTypeAttr

    IDfAttr getTypeAttr(int attrIndex) throws DfException
    Returns an IDfAttr representing the type's attribute located at the position `attrIndex` in this object's list of attributes.
    Parameters:
      `attrIndex` - the index position of the attribute among the object's types
    Returns:
      an IDfAttr interface to the attribute
    Throws:
      `DfException` - if a server error occurs
    See Also:
      - `findTypeAttrIndex(java.lang.String)`

  - ### getTypeAttrNameAt

    String getTypeAttrNameAt(int index) throws DfException
    Returns an attribute name for a type.
    Throws:
      `DfException` - if a server error occurs

  - ### getTypeAttrDataType

    int getTypeAttrDataType(String attrName) throws DfException
    Returns the datatype of an attribute.

    The following list specifies the datatype corresponding to all possible return values:

         Value Datatype
         0            Boolean
         1            Integer
         2            String
         3            ID
         4            Time, or date
         5            Double
         6            Undefined

    Throws:
      `DfException` - if a server error occurs

  - ### getTypeAttrDataTypeAt

    int getTypeAttrDataTypeAt(int index) throws DfException
    Returns the datatype of an attribute.

    The following list specifies the datatype corresponding to all return values.

         Value Datatype
         0            Boolean
         1            Integer
         2            String
         3            ID
         4            Time, or date
         5            Double
         6            Undefined

    Throws:
      `DfException` - if a server error occurs

  - ### isTypeAttrRepeating

    boolean isTypeAttrRepeating(String attrName) throws DfException
    Indicates whether an attribute is repeating.
    Throws:
      `DfException` - if a server error occurs

  - ### isTypeAttrRepeatingAt

    boolean isTypeAttrRepeatingAt(int index) throws DfException
    Indicates whether an attribute is repeating.
    Throws:
      `DfException` - if a server error occurs

  - ### getTypeAttrLength

    int getTypeAttrLength(String attrName) throws DfException
    Returns the maximum number of characters in a string-valued attribute.

    This method returns 0 for all attributes storing non-string values.

    Throws:
      `DfException` - if a server error occurs

  - ### getTypeAttrLengthAt

    int getTypeAttrLengthAt(int index) throws DfException
    Returns the maximum number of characters in a string-valued attribute.

    This method returns 0 for all attributes storing non-string values.

    Throws:
      `DfException` - if a server error occurs

  - ### getTypeAttrDescription

    String getTypeAttrDescription(String attrName) throws DfException
    Returns the user-defined label for an attribute.
    Throws:
      `DfException` - if a server error occurs

  - ### getTypeAttrDescriptionAt

    String getTypeAttrDescriptionAt(int index) throws DfException
    Returns the user-defined label for an attribute.
    Throws:
      `DfException` - if a server error occurs

  - ### getTypeValidator

    IDfValidator getTypeValidator(IDfId policyId, String state) throws DfException
    Returns the IDfValidator that is assocated with this IDfType. IDfValidator provides validation-related services. Attribute level validation results could vary depending on the attribute values of its depending attributes.
    Returns:
      the IDfValidator that is assocated with this IDfType
    Throws:
      `DfException`

  - ### validateTypeAttrRulesWithValue

    void validateTypeAttrRulesWithValue(String attrName, IDfId policyId, String state, String value, IDfList depAttrNameList, IDfList depAttrValueListList, int stopAfterNumOfErrors) throws DfException
    Deprecated.
    Validates a user-supplied value.

    THIS METHOD IS DEPRECATED -- use getTypeValidator and then call validateAttrRules on IDfValidator with the appropriate parameters instead.
    Throws:
      `DfException`

  - ### validateTypeAttrRulesWithValues

    void validateTypeAttrRulesWithValues(String attrName, IDfId policyId, String state, IDfList values, IDfList depAttrNameList, IDfList depAttrValueListList, int stopAfterNumOfErrors) throws DfException
    Deprecated.
    Validates a list of user-supplied values.

    THIS METHOD IS DEPRECATED -- use getTypeValidator and then call validateAttrRules on IDfValidator with the appropriate parameters instead.
    Throws:
      `DfException`

  - ### validateTypeObjRulesWithValues

    void validateTypeObjRulesWithValues(IDfList attrNameList, IDfId policyId, String state, IDfList valueListList, int stopAfterNumOfErrors) throws DfException
    Deprecated.
    Performs object-level validation on a list of user-supplied values.

    THIS METHOD IS DEPRECATED -- use getTypeValidator and then call validateAllObjRules on IDfValidator with the appropriate parameters instead.
    Parameters:
      `stopAfterNumOfErrors` - The maximum number of violations this method will detect Pass zero to this parameter if you want the method to finish validating regardless of the number of violations
    Throws:
      `DfException`

  - ### getTypeAttrAsstDependencies

    IDfList getTypeAttrAsstDependencies(String attrName, IDfId policyId, String state) throws DfException
    Deprecated.
    Lists the attributes on which an attribute's validation rule depends.

    THIS METHOD IS DEPRECATED -- use getTypeValidator and then call getValueAssistanceDependencies on IDfValidator with the appropriate parameters instead.
    Throws:
      `DfException` - if a server error occurs

  - ### getTypeAttrAssistanceWithValues

    IDfList getTypeAttrAssistanceWithValues(String attrName, IDfId policyId, String state, IDfList depAttrNameList, IDfList depAttrValueListList) throws DfException
    Deprecated.
    Lists all legal values for an attribute.

    The first element (at index 0) of the return value is a list of possible actual values for the specified attribute. The second element (at index 1) of the return value is a list of the possible values being value-mapped.
    For example, `getTypeAttrAssistance(String attrName, IDfId policyId, String state).getList(0)` will return a list of possible actual values; `getTypeAttrAssistance(String attrName, IDfId policyId, String state).getList(1)` will return a list of value-mapped possible values. THIS METHOD IS DEPRECATED -- use getTypeValidator and then call getValueAssistance on IDfValidator with the appropriate parameters to get IDfValueAssistance.
    Throws:
      `DfException` - if a server error occurs

  - ### getTypeWidgetType

    String getTypeWidgetType(int environment, String attrName, IDfId policyId, String state) throws DfException
    Deprecated.
    Returns the appropriate widget to use, given specific development environment, attribute, business policy and the state of the business policy.

    If you are developing in a Java environment, this method returns the Class name of the appropriate widget. If you are developing in a Visual Basic or Visual C++ environment, the widget's CLSID is returned.

    THIS METHOD IS DEPRECATED -- use getTypeValidator and then call getWidgetType on IDfValidator with the appropriate parameters instead.
    Throws:
      `DfException` - if a server error occurs